Program Ext60;
Uses
  Crt, WinDos;
Const
  n = 100;                               { ᨬ쭮 ⢮ 祭 }
  Param = 6;                             { ᥣ ࠬ஢ }
  FileName = 'Ext60.dat';
  RusLiter = ' ';
  mes1 = '***    ***';
  mes2 = ' 室  .';
  mes3 = '⢮      100.';
  mes4 = '訡  䠩 室 .';
  mes5 = '""  ""  ᮤঠ ⮫쪮 ᪨ ᨬ.';
  mes6 = '訡:  ஦    1900  2100';
  mes7 = '訡: 業    0  5';
  mes8 = '室 ᨢ 祭:';
  mes9 = ').  ।:';
  mes10 = ').  㭨:';
  mes11 = ').  । । ᠬ 㭨:';
  mes12 = ').  㭨 । ᠬ ।:';
  mes13 = ' 室 䠩  ⮫쪮   祭!';

Type
  Data1 = record
    Family : String[12];                 {  }
    Name   : String[12];                 {  }
    Year   : String[4];                  {  ஦ }
    Result : array[1..Param] of Integer; { ࠬ }
  end;
  Data = array[1..n] of Data1;           { ᨢ  祭 }

Var
  i, j, t : Integer;
  F : text;
  D : Data;
  St : String;
  Sr, Sr1 : Data;
  Un, Un1 : Data;
  s, u : Integer;
  Year : Integer;

Procedure InitMas(Var A : Data);
var
  t1 : integer;
begin
  for t1 := 1 to n do begin
    A[t1].Family := '';
    A[t1].Name := '';
    A[t1].Year := '';
  end;
end;

{ 楤 ନ஢ ᨢ...
  X[] - 室, ᨢ ᠬ ।
  Z[] - 室, ᨢ ᠬ 㭨
  Y[] - 室, 室 ᨢ
Count - ᫮ 祭  室 ᨢ }

Procedure Mid(Var X, Z: Data; Y : Data; Count : Integer);
Var
  Medium : array[1..Param] of Real;
  Min : array[1..Param] of Real;
  Max : array[1..Param] of Real;
  EMin : array[1..n] of Integer;
  EMax : array[1..n] of Integer;
  j, k : Integer;
  Tmp, Tmp1, Tmp2 : real;
  x1, x2 : Integer;

begin

  { 樠 ६ }
  x1 := 0; Tmp1 := 0;
  x2 := 0; Tmp2 := 0;

  For j := 1 to Count do begin
    EMin[j] := 0;
    EMax[j] := 0;
  end;
  For k := 1 to Param do begin
    Medium[k] := 0;
    Min[k] := MaxInt;
    Max[k] := -MaxInt;
  end;
  InitMas(X); InitMas(Z);

  { 㬬஢  ⮢ k- ࠬ }
  for j := 1 to Count do begin
    for k := 1 to Param do
       Medium[k] := Medium[k] + Y[j].Result[k];
  end;
  { ஢ ᨢ 㬮  ᨬ㬮
    ࠧ । 䬥᪮  k- }
  For j := 1 to Count do begin
    for k := 1 to Param do begin
      Tmp := Abs(Y[j].Result[k] - Medium[k]/Count);
      If Min[k] > Tmp then Min[k] := Tmp;
      If Max[k] < Tmp then Max[k] := Tmp;
    end;
  end;

  { 室 ⢮ 㬮  ᨬ㬮   ப }
  For j := 1 to Count do
    For k := 1 to Param do begin
    Tmp := Abs(Y[j].Result[k] - Medium[k]/Count);
    If (Min[k] = Tmp) then EMin[j] := EMin[j] + 1;
    If (Max[k] = Tmp) then EMax[j] := EMax[j] + 1;
    end;

  { 室 ᨬ । ⮢ EMin, EMax }
  For j := 1 to Count do begin
    If EMin[j] > Tmp1 Then Tmp1 := EMin[j];
    If EMax[j] > Tmp2 Then Tmp2 := EMax[j];
  end;

  { ࠭ १⮢  ᨢ X[]  Z[] }
  For j := 1 to Count do begin
    If EMin[j] = Tmp1 then begin
       Inc(x1);
       X[x1] := Y[j];
    end;
    If EMax[j] = Tmp2 then begin
       Inc(x2);
       Z[x2] := Y[j];
    end;
  end;
  If x1 = Count then InitMas(X);
  If x2 = Count then InitMas(Z);
end;

{ ================    ================ }

Begin
  ClrScr;
  i := 0;
  Assign(F, FileName);
  Reset(F);
  If Eof(F) then begin
     WriteLn(mes2); Halt(1);
  end;
  while not eof(F) do begin
    Inc(i);
    Read(F, D[i].Family);
    Read(F, D[i].Name);
    For t := 1 to 12 do
      If Pos(D[i].Family[t], RusLiter) = 0 then begin
         WriteLn(mes5); Halt(1);
      end;
    For t := 1 to 12 do
      If Pos(D[i].Name[t], RusLiter) = 0 then begin
         WriteLn(mes5); Halt(1);
      end;
    Read(F, D[i].Year);
    Val(D[i].Year, Year, t);
    If (Year < 1900) or (Year > 2100) then begin
       WriteLn(mes6); Halt(1);
    end;
    ReadLn(F, St);
    j := 0;
    repeat
      Inc(j);
      Val(Copy(St, 2*j-1, 2), D[i].Result[j], t);
      If (D[i].Result[j] < 0) or (D[i].Result[j] > 5) then begin
         WriteLn(mes7); Halt(1);
      end;
    until 2*j-1 > Length(St);
    If j-1 <> Param then begin
       WriteLn(mes4); Halt(1);
    end;
  end;
  Close(F);

  { 뢮 室 ᨢ ( 祭)  ࠭ }
  TextColor(14); WriteLn(mes8);
  TextColor(7);
  For t := 1 to i do begin
    Write(D[t].Family);
    Write(D[t].Name);
    Write(D[t].Year);
    For s := 1 to Param do
    Write(D[t].Result[s]:2);
    WriteLn;
  end;
  WriteLn(mes1);
  if i <= 1 then begin
     WriteLn(mes13); Halt(1);
  end;
  repeat until KeyPressed;
  ClrScr;

  { 뢮 १⮢ }

  Mid(Sr, Un, D, i);
  TextColor(14); WriteLn(mes9); s := 1;
  TextColor(7);
  While Sr[s].Family[0] <> #0 do begin
    WriteLn(Sr[s].Family, Sr[s].Name);
    Inc(s);
  end;
  TextColor(14); WriteLn(mes10); u := 1;
  TextColor(7);
  While Un[u].Family[0] <> #0 do begin
    WriteLn(Un[u].Family, Un[u].Name);
    Inc(u);
  end;

  Mid(Sr1, Un1, Un, u-1);

  TextColor(14); WriteLn(mes11); t := 1;
  TextColor(7);
  While Sr1[t].Family[0] <> #0 do begin
    WriteLn(Sr1[t].Family, Sr1[t].Name);
    Inc(t);
  end;

  Mid(Sr1, Un1, Sr, s-1);

  TextColor(14); WriteLn(mes12); t := 1;
  TextColor(7);
  While Un1[t].Family[0] <> #0 do begin
    WriteLn(Un1[t].Family, Un1[t].Name);
    Inc(t);
  end;
  repeat until KeyPressed;
End.
